Imports ColoredGrid.MeasureDataSet

Public Class frmColoredGrid

    Private Sub MenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) _
        Handles SaveToolStripMenuItem.Click, ReLoadToolStripMenuItem.Click, _
        RandomMeasureToolStripMenuItem.Click

        Select Case True
            Case sender Is RandomMeasureToolStripMenuItem
                Dim T As DateTime = GetRow(Of MeasureRow)( _
                    MeasureBindingSource( _
                        MeasureBindingSource.Count - 1)).TimeStamp
                Dim Rnd As New Random(Environment.TickCount)
                For I As Integer = 0 To 19
                    T += TimeSpan.FromSeconds(50)
                    Me.MeasureDataSet.Measure.AddMeasureRow(Rnd.Next(0, 100), T)
                Next

            Case sender Is ReLoadToolStripMenuItem
                ' Zu beachten: Da dem TU kein DatenFile beiliegt, mu erst 
                '  eines mit "Save" erstellt werden, bevor es geladen werden 
                '  kann
                Me.MeasureDataSet.Clear()
                Me.MeasureDataSet.ReadXml("Measure.Dataset")

            Case sender Is SaveToolStripMenuItem
                ' EndEdit() bewirkt die bernahme der aktuellen Zeile in die 
                '  Datasource. Andernfalls wrden die letzten nderungen nicht 
                '  mit abgespeichert, da nderungen erst beim Wechsel der Zeile 
                '  in die DataSource rckgeschrieben werden 
                Me.MeasureDataGridView.EndEdit()
                Me.MeasureBindingSource.EndEdit()
                Me.MeasureDataSet.WriteXml("Measure.Dataset")

        End Select
    End Sub

    Private Sub MeasureDataGridView_RowPrePaint(ByVal sender As Object, _
        ByVal e As DataGridViewRowPrePaintEventArgs) _
        Handles MeasureDataGridView.RowPrePaint

        If e.RowIndex < 0 OrElse _
            e.RowIndex >= MeasureBindingSource.Count Then Return
        Dim Rw As DataGridViewRow = Me.MeasureDataGridView.Rows(e.RowIndex)
        Dim Col As Color

        Select Case GetRow(Of MeasureRow) _
            (MeasureBindingSource(e.RowIndex)).Temperature

            Case Is < 15
                Col = Color.LightBlue
            Case Is < 70
                Col = Color.LightGreen
            Case Is < 85
                Col = Color.Orange
            Case Else
                Col = Color.OrangeRed
        End Select

        If Not AssignSave(Rw.DefaultCellStyle.BackColor, Col) Then Return
        ' SelectionBackColor dunkler tnen
        Col = Color.FromArgb((Col.R * 2) \ 3, (Col.G * 2) \ 3, (Col.B * 2) \ 3)
        AssignSave(Rw.DefaultCellStyle.SelectionBackColor, Col)
    End Sub

End Class
